// Fran Jarnjak
// June 2007
// fjarnjak_at_gmail_dot_com

// Main 

// Makes Serial IO object engine and communicates with PLC using serial port
// Parameters:

// filename + serial port path name

// Type quit to exit the loop


#include "SerialIO.h"
#include <iostream>
#include <stdexcept>

using namespace std;


int main(int argc, char **argv)
{
   if(argc<2)
   {
     cout << "Usage: " << argv[0] << " <serial port path>" << endl;
     cout << "\nFor example: " << argv[0] << " /dev/tty.usbserial" << endl;
   }

   SerialIO * engine = NULL;

    bool done = false;
    char buff[256]; // Output buffer (to PLC)
    char readBuff[256]; // Input buffer (from PLC)
    int len =0;
    int resultSize = 0;
    
    try 
    {
       engine = new SerialIO(argv[1]);
    }catch(...)
    {
        cout << "Exception making ModbusEngine" << endl;
        return 1;
    }
    
    while(!done)
    {
        cout << "Enter msg to send:";
        cin >> buff;
        len = strlen(buff);
        resultSize = 256;
        
        if(!strcmp(buff, "quit"))
        {
            cout << "Quit entered" << endl;
            done = true;
            break;
        }
        
        buff[len] = 13; // make 13 as ending char
        
        // Debug
        cout << "To be written to Serial port:" << endl;
        for(int i=0;i<len+1;i++)
            cout << " buff[" << i << "]: " << (int)buff[i] << endl;
        
        try 
        {
            engine->sendBytes(buff, len+1, readBuff, &resultSize);
            if(resultSize <=0)
            {
                cout << "Read 0 bytes" << endl;
                continue;
            }
            else
            {
                cout << "Response from Serial port (" << resultSize << " bytes):" << endl;
                for(int i=0;i<resultSize;i++)
                {
                    if(readBuff[i]!=13)
                       cout << " readBuff[" << i << "]: " << readBuff[i]  << " (int=" << (int)readBuff[i] << ")" << endl;
                    else
                       cout << " readBuff[" << i << "]: = 13 (\\r)" << endl;
                }
                cout << endl << endl;
            }
        }
        catch(const std::runtime_error& error)
        {
            cout << "Error: " << error.what() << endl;
        }
        catch(...)
        {
            cout << "General error in menu loop" << endl;
        }
    }
    
    if(engine) delete engine;
    
   cout << "Exiting" << endl;
}
